package scene;

/*
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
*/
import java.awt.*;
import java.util.*;
import java.beans.*;
import java.lang.reflect.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.tree.*;


public class Window extends javax.swing.JFrame {

    public Window() {
        initComponents();

        // registerClasses ();
        readText ();

        // setupTree (this);
        setupTree (jPanel);

        // setupScene (jPanel);
    }
    
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jVertSplit1 = new javax.swing.JSplitPane();
        jToolBar = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jVertSplit2 = new javax.swing.JSplitPane();
        jHorizSplit1 = new javax.swing.JSplitPane();
        jTreeScrollPane = new javax.swing.JScrollPane();
        jTree = new javax.swing.JTree();
        jHorizSplit2 = new javax.swing.JSplitPane();
        jPanel = new javax.swing.JPanel();
        jTableScrollPane = new javax.swing.JScrollPane();
        jTable = new javax.swing.JTable();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jVertSplit1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jToolBar.setRollover(true);

        jButton1.setText("jButton1");
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar.add(jButton1);

        jVertSplit1.setLeftComponent(jToolBar);

        jVertSplit2.setDividerLocation(700);
        jVertSplit2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jHorizSplit1.setDividerLocation(200);

        jTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTreeValueChanged(evt);
            }
        });
        jTreeScrollPane.setViewportView(jTree);

        jHorizSplit1.setLeftComponent(jTreeScrollPane);

        jHorizSplit2.setDividerLocation(600);

        javax.swing.GroupLayout jPanelLayout = new javax.swing.GroupLayout(jPanel);
        jPanel.setLayout(jPanelLayout);
        jPanelLayout.setHorizontalGroup(
            jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 599, Short.MAX_VALUE)
        );
        jPanelLayout.setVerticalGroup(
            jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 695, Short.MAX_VALUE)
        );

        jHorizSplit2.setLeftComponent(jPanel);

        jTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTableScrollPane.setViewportView(jTable);

        jHorizSplit2.setRightComponent(jTableScrollPane);

        jHorizSplit1.setRightComponent(jHorizSplit2);

        jVertSplit2.setLeftComponent(jHorizSplit1);

        jTextArea.setColumns(20);
        jTextArea.setRows(5);
        jScrollPane1.setViewportView(jTextArea);

        jVertSplit2.setRightComponent(jScrollPane1);

        jVertSplit1.setBottomComponent(jVertSplit2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jVertSplit1, javax.swing.GroupLayout.DEFAULT_SIZE, 1022, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jVertSplit1)
                .addGap(0, 0, 0))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTreeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTreeValueChanged
        Object last = evt.getPath ().getLastPathComponent ();
        if (last instanceof DefaultMutableTreeNode)
        {
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) last;
            Object obj = node.getUserObject ();
            setupTable (obj);
        }
    }//GEN-LAST:event_jTreeValueChanged

    /* ------------------------------------------------------------------ */
    
    private void put (String s)
    {
        jTextArea.append (s + "\n");
    }
    
    /* ------------------------------------------------------------------ */

    /*
    private void setupScene (Container target)
    {
        // Setup a SimpleUniverse by referencing a Canvas3D
        GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
        Canvas3D canvas = new Canvas3D (config);
        Container cp = target;
        cp.setLayout (new BorderLayout ());
        cp.add (canvas, BorderLayout.CENTER);
        SimpleUniverse universe = new SimpleUniverse (canvas);

        // Set up the viewer looking into the scene.
        universe.getViewingPlatform().setNominalViewingTransform();

        // Create the content branch and add it to the universe
        BranchGroup scene = createSceneGraph();
        universe.addBranchGraph(scene);      
    }

    private BranchGroup createSceneGraph() {
        // Create the root node of the content branch
        BranchGroup nodeRoot = new BranchGroup ();

        // Create the TransformGroup node, which is writable to support
        // animation, and add it under the root
        TransformGroup nodeTrans = new TransformGroup ();
        nodeTrans.setCapability (TransformGroup.ALLOW_TRANSFORM_WRITE);
        nodeRoot.addChild (nodeTrans);

        // Create a visual object node (color cube) and add it to the scene.
        addObjects (nodeTrans);

        // Create a Behavior node to rotate the cube add it to the scene.
        Transform3D yAxis = new Transform3D ();
        Alpha timing = new Alpha (-1, 4000);
        RotationInterpolator nodeRotator = new RotationInterpolator 
            (timing, nodeTrans, yAxis, 0.0f, (float) Math.PI * 2.0f);
        BoundingSphere bounds = new BoundingSphere (new Point3d (0.0, 0.0, 0.0), 100.0);
        nodeRotator.setSchedulingBounds (bounds);
        nodeRoot.addChild (nodeRotator);

        // Compile to perform optimizations on this content branch.
        nodeRoot.compile ();

        return nodeRoot;
    }
    
    private void addObjects (Group group)
    {
        group.addChild (new ColorCube (0.4));
    }
    */
    
    /* ------------------------------------------------------------------ */

    private void setupTree (Object obj)
    {
        DefaultMutableTreeNode root = createBranch (obj);
        DefaultTreeModel model = new DefaultTreeModel (root);
        jTree.setModel (model);
    }
    
    private DefaultMutableTreeNode createBranch (Object obj)
    {
        DefaultMutableTreeNode result = new DefaultMutableTreeNode (obj);
        if (obj instanceof Container)
        {
            Container container = (Container) obj;
            for (Component c : container.getComponents ())
               result.add (createBranch (c));
        }
        return result;
    }
    
    private void setupTable (Object obj)
    {
        Vector <String> columns = new Vector <String> ();
        columns.add ( "Name");
        columns.add ( "Value" );
        Vector <Vector <Object> > data = new Vector <Vector <Object> > () ;
        
        Class cls = obj.getClass ();
        try 
        {
            BeanInfo info = Introspector.getBeanInfo (cls);
            PropertyDescriptor[] properties = info.getPropertyDescriptors ();
            for (PropertyDescriptor prop : properties)
            {
               String name = prop.getDisplayName ();
               Object value = null;
               Method meth = prop.getReadMethod ();
               if (meth != null)
               {
                   try 
                   {
                       value = meth.invoke (obj);
                   }
                   catch (IllegalAccessException ex) { }
                   catch (IllegalArgumentException ex) { }
                   catch (InvocationTargetException ex) { }
               }
               
               Vector <Object> line = new Vector <Object> ();
               line.add (name);
               line.add (value);
               data.add (line);
            }
        } 
        catch (IntrospectionException ex) 
        {
        }
        
        DefaultTableModel model = new DefaultTableModel (data, columns);
        jTable.setModel (model);
    }
    
    /* ------------------------------------------------------------------ */
    
    private void simpleReadText ()
    {
        Parser f = new Parser ("abc.txt");
        String name = f.readIdentifier ();
        
        f.checkSeparator ('{');
        while (! f.isSeparator('}'))
        {
            String field = f.readIdentifier();
            f.checkSeparator ('=');
            
            Object value = f.readValue();
            f.checkSeparator (';');
        }
        f.checkSeparator('}');
    }
    
    /* ------------------------------------------------------------------ */

    private Hashtable <String, Class> classDict = new Hashtable <String, Class>() { };
    
    private void registerClasse (Class cls)
    {
        classDict.put (cls.getSimpleName(), cls);
    }
    
    private void registerClasses ()
    {
        registerClasse (JButton.class);
        registerClasse (JPanel.class);
        registerClasse (JTree.class);
    }
    
    /* ------------------------------------------------------------------ */

    private void readText ()
    {
        Parser f = new Parser ("abc.txt");
        String name = f.readIdentifier ();
        
        // Class cls = classDict.get (name);
        // if (cls == null) f.error ("Unknown class: " + name);
        name = "javax.swing." + name;
        Class cls = null;
        try 
        {
            cls = Class.forName (name);
        } catch (ClassNotFoundException ex) { f.error (ex); }
        
        Object obj = null;
        try 
        {
            obj = cls.newInstance ();
        } 
        catch (Exception ex) { f.error (ex); }
        
        
        BeanInfo info = null;
        try 
        {
            info = Introspector.getBeanInfo (cls);
        } 
        catch (IntrospectionException ex) { f.error (ex); }

        PropertyDescriptor[] properties = info.getPropertyDescriptors ();
        
        f.checkSeparator ('{');
        while (! f.isSeparator('}'))
        {
            String field = f.readIdentifier();
            
            PropertyDescriptor prop = null;
            // for (PropertyDescriptor p : properties)
            //     put (p.getName());
            for (PropertyDescriptor p : properties)
                if (p.getName().equals (field))
                    prop = p;
            if (prop == null) 
               f.error ("Unknown property: " + field);

            f.checkSeparator ('=');
            Object value = f.readValue();
            
            Method m = prop.getWriteMethod();
            if (m == null) f.error ("Read only property: " + field);
            Object [] params = new Object [] { value };
            try 
            {
                m.invoke (obj, params);
            } 
            catch (Exception ex) { f.error (ex); }
            
            f.checkSeparator (';');
        }
        f.checkSeparator('}');
        
        if (obj instanceof Component)
        {
            Component comp = (Component) obj;
            comp.setSize (200, 24);
            jPanel.add(comp);
        }
    }

    /* ------------------------------------------------------------------ */

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JSplitPane jHorizSplit1;
    private javax.swing.JSplitPane jHorizSplit2;
    private javax.swing.JPanel jPanel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable;
    private javax.swing.JScrollPane jTableScrollPane;
    private javax.swing.JTextArea jTextArea;
    private javax.swing.JToolBar jToolBar;
    private javax.swing.JTree jTree;
    private javax.swing.JScrollPane jTreeScrollPane;
    private javax.swing.JSplitPane jVertSplit1;
    private javax.swing.JSplitPane jVertSplit2;
    // End of variables declaration//GEN-END:variables
}

// http://www.java3d.org/tutorial.html
// http://www.ntu.edu.sg/home/ehchua/programming/opengl/Java3D.html

// abc.txt
// JButton { text = "Nadpis"; }
